/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableSystem {
  SystemEventType_EventId((int) 3653L),
  SystemEventType_EventType((int) 3654L),
  SystemEventType_SourceNode((int) 3655L),
  SystemEventType_SourceName((int) 3656L),
  SystemEventType_Time((int) 3657L),
  SystemEventType_ReceiveTime((int) 3658L),
  SystemEventType_LocalTime((int) 3659L),
  SystemEventType_Message((int) 3660L),
  SystemEventType_Severity((int) 3661L),
  SystemStatusChangeEventType_EventId((int) 11447L),
  SystemStatusChangeEventType_EventType((int) 11448L),
  SystemStatusChangeEventType_SourceNode((int) 11449L),
  SystemStatusChangeEventType_SourceName((int) 11450L),
  SystemStatusChangeEventType_Time((int) 11451L),
  SystemStatusChangeEventType_ReceiveTime((int) 11452L),
  SystemStatusChangeEventType_LocalTime((int) 11453L),
  SystemStatusChangeEventType_Message((int) 11454L),
  SystemStatusChangeEventType_Severity((int) 11455L),
  SystemStatusChangeEventType_SystemState((int) 11696L),
  SystemOffNormalAlarmType_EventId((int) 11754L),
  SystemOffNormalAlarmType_EventType((int) 11755L),
  SystemOffNormalAlarmType_SourceNode((int) 11756L),
  SystemOffNormalAlarmType_SourceName((int) 11757L),
  SystemOffNormalAlarmType_Time((int) 11758L),
  SystemOffNormalAlarmType_ReceiveTime((int) 11759L),
  SystemOffNormalAlarmType_LocalTime((int) 11760L),
  SystemOffNormalAlarmType_Message((int) 11761L),
  SystemOffNormalAlarmType_Severity((int) 11762L),
  SystemOffNormalAlarmType_ConditionClassId((int) 11763L),
  SystemOffNormalAlarmType_ConditionClassName((int) 11764L),
  SystemOffNormalAlarmType_ConditionName((int) 11765L),
  SystemOffNormalAlarmType_BranchId((int) 11766L),
  SystemOffNormalAlarmType_Retain((int) 11767L),
  SystemOffNormalAlarmType_EnabledState((int) 11768L),
  SystemOffNormalAlarmType_EnabledState_Id((int) 11769L),
  SystemOffNormalAlarmType_EnabledState_Name((int) 11770L),
  SystemOffNormalAlarmType_EnabledState_Number((int) 11771L),
  SystemOffNormalAlarmType_EnabledState_EffectiveDisplayName((int) 11772L),
  SystemOffNormalAlarmType_EnabledState_TransitionTime((int) 11773L),
  SystemOffNormalAlarmType_EnabledState_EffectiveTransitionTime((int) 11774L),
  SystemOffNormalAlarmType_EnabledState_TrueState((int) 11775L),
  SystemOffNormalAlarmType_EnabledState_FalseState((int) 11776L),
  SystemOffNormalAlarmType_Quality((int) 11777L),
  SystemOffNormalAlarmType_Quality_SourceTimestamp((int) 11778L),
  SystemOffNormalAlarmType_LastSeverity((int) 11779L),
  SystemOffNormalAlarmType_LastSeverity_SourceTimestamp((int) 11780L),
  SystemOffNormalAlarmType_Comment((int) 11781L),
  SystemOffNormalAlarmType_Comment_SourceTimestamp((int) 11782L),
  SystemOffNormalAlarmType_ClientUserId((int) 11783L),
  SystemOffNormalAlarmType_AddComment_InputArguments((int) 11787L),
  SystemOffNormalAlarmType_ConditionRefresh_InputArguments((int) 11789L),
  SystemOffNormalAlarmType_AckedState((int) 11790L),
  SystemOffNormalAlarmType_AckedState_Id((int) 11791L),
  SystemOffNormalAlarmType_AckedState_Name((int) 11792L),
  SystemOffNormalAlarmType_AckedState_Number((int) 11793L),
  SystemOffNormalAlarmType_AckedState_EffectiveDisplayName((int) 11794L),
  SystemOffNormalAlarmType_AckedState_TransitionTime((int) 11795L),
  SystemOffNormalAlarmType_AckedState_EffectiveTransitionTime((int) 11796L),
  SystemOffNormalAlarmType_AckedState_TrueState((int) 11797L),
  SystemOffNormalAlarmType_AckedState_FalseState((int) 11798L),
  SystemOffNormalAlarmType_ConfirmedState((int) 11799L),
  SystemOffNormalAlarmType_ConfirmedState_Id((int) 11800L),
  SystemOffNormalAlarmType_ConfirmedState_Name((int) 11801L),
  SystemOffNormalAlarmType_ConfirmedState_Number((int) 11802L),
  SystemOffNormalAlarmType_ConfirmedState_EffectiveDisplayName((int) 11803L),
  SystemOffNormalAlarmType_ConfirmedState_TransitionTime((int) 11804L),
  SystemOffNormalAlarmType_ConfirmedState_EffectiveTransitionTime((int) 11805L),
  SystemOffNormalAlarmType_ConfirmedState_TrueState((int) 11806L),
  SystemOffNormalAlarmType_ConfirmedState_FalseState((int) 11807L),
  SystemOffNormalAlarmType_Acknowledge_InputArguments((int) 11809L),
  SystemOffNormalAlarmType_Confirm_InputArguments((int) 11811L),
  SystemOffNormalAlarmType_ActiveState((int) 11812L),
  SystemOffNormalAlarmType_ActiveState_Id((int) 11813L),
  SystemOffNormalAlarmType_ActiveState_Name((int) 11814L),
  SystemOffNormalAlarmType_ActiveState_Number((int) 11815L),
  SystemOffNormalAlarmType_ActiveState_EffectiveDisplayName((int) 11816L),
  SystemOffNormalAlarmType_ActiveState_TransitionTime((int) 11817L),
  SystemOffNormalAlarmType_ActiveState_EffectiveTransitionTime((int) 11818L),
  SystemOffNormalAlarmType_ActiveState_TrueState((int) 11819L),
  SystemOffNormalAlarmType_ActiveState_FalseState((int) 11820L),
  SystemOffNormalAlarmType_InputNode((int) 11821L),
  SystemOffNormalAlarmType_SuppressedState((int) 11822L),
  SystemOffNormalAlarmType_SuppressedState_Id((int) 11823L),
  SystemOffNormalAlarmType_SuppressedState_Name((int) 11824L),
  SystemOffNormalAlarmType_SuppressedState_Number((int) 11825L),
  SystemOffNormalAlarmType_SuppressedState_EffectiveDisplayName((int) 11826L),
  SystemOffNormalAlarmType_SuppressedState_TransitionTime((int) 11827L),
  SystemOffNormalAlarmType_SuppressedState_EffectiveTransitionTime((int) 11828L),
  SystemOffNormalAlarmType_SuppressedState_TrueState((int) 11829L),
  SystemOffNormalAlarmType_SuppressedState_FalseState((int) 11830L),
  SystemOffNormalAlarmType_ShelvingState_CurrentState((int) 11832L),
  SystemOffNormalAlarmType_ShelvingState_CurrentState_Id((int) 11833L),
  SystemOffNormalAlarmType_ShelvingState_CurrentState_Name((int) 11834L),
  SystemOffNormalAlarmType_ShelvingState_CurrentState_Number((int) 11835L),
  SystemOffNormalAlarmType_ShelvingState_CurrentState_EffectiveDisplayName((int) 11836L),
  SystemOffNormalAlarmType_ShelvingState_LastTransition((int) 11837L),
  SystemOffNormalAlarmType_ShelvingState_LastTransition_Id((int) 11838L),
  SystemOffNormalAlarmType_ShelvingState_LastTransition_Name((int) 11839L),
  SystemOffNormalAlarmType_ShelvingState_LastTransition_Number((int) 11840L),
  SystemOffNormalAlarmType_ShelvingState_LastTransition_TransitionTime((int) 11841L),
  SystemOffNormalAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime((int) 11842L),
  SystemOffNormalAlarmType_ShelvingState_UnshelveTime((int) 11843L),
  SystemOffNormalAlarmType_ShelvingState_TimedShelve_InputArguments((int) 11847L),
  SystemOffNormalAlarmType_SuppressedOrShelved((int) 11848L),
  SystemOffNormalAlarmType_MaxTimeShelved((int) 11849L),
  SystemOffNormalAlarmType_NormalState((int) 11850L),
  SystemOffNormalAlarmType_ConditionRefresh2_InputArguments((int) 13009L),
  SystemOffNormalAlarmType_ConditionSubClassId((int) 16972L),
  SystemOffNormalAlarmType_ConditionSubClassName((int) 16973L),
  SystemOffNormalAlarmType_OutOfServiceState((int) 16974L),
  SystemOffNormalAlarmType_OutOfServiceState_Id((int) 16975L),
  SystemOffNormalAlarmType_OutOfServiceState_Name((int) 16976L),
  SystemOffNormalAlarmType_OutOfServiceState_Number((int) 16977L),
  SystemOffNormalAlarmType_OutOfServiceState_EffectiveDisplayName((int) 16978L),
  SystemOffNormalAlarmType_OutOfServiceState_TransitionTime((int) 16979L),
  SystemOffNormalAlarmType_OutOfServiceState_EffectiveTransitionTime((int) 16980L),
  SystemOffNormalAlarmType_OutOfServiceState_TrueState((int) 16981L),
  SystemOffNormalAlarmType_OutOfServiceState_FalseState((int) 16982L),
  SystemOffNormalAlarmType_SilenceState((int) 16983L),
  SystemOffNormalAlarmType_SilenceState_Id((int) 16984L),
  SystemOffNormalAlarmType_SilenceState_Name((int) 16985L),
  SystemOffNormalAlarmType_SilenceState_Number((int) 16986L),
  SystemOffNormalAlarmType_SilenceState_EffectiveDisplayName((int) 16987L),
  SystemOffNormalAlarmType_SilenceState_TransitionTime((int) 16988L),
  SystemOffNormalAlarmType_SilenceState_EffectiveTransitionTime((int) 16989L),
  SystemOffNormalAlarmType_SilenceState_TrueState((int) 16990L),
  SystemOffNormalAlarmType_SilenceState_FalseState((int) 16991L),
  SystemOffNormalAlarmType_AudibleEnabled((int) 16992L),
  SystemOffNormalAlarmType_AudibleSound((int) 16993L),
  SystemOffNormalAlarmType_OnDelay((int) 16998L),
  SystemOffNormalAlarmType_OffDelay((int) 16999L),
  SystemOffNormalAlarmType_FirstInGroupFlag((int) 17000L),
  SystemOffNormalAlarmType_ReAlarmTime((int) 17003L),
  SystemOffNormalAlarmType_ReAlarmRepeatCount((int) 17004L),
  SystemOffNormalAlarmType_ShelvingState_AvailableStates((int) 17696L),
  SystemOffNormalAlarmType_ShelvingState_AvailableTransitions((int) 17697L),
  SystemOffNormalAlarmType_AudibleSound_ListId((int) 17956L),
  SystemOffNormalAlarmType_AudibleSound_AgencyId((int) 17957L),
  SystemOffNormalAlarmType_AudibleSound_VersionId((int) 17958L),
  SystemOffNormalAlarmType_LatchedState((int) 18327L),
  SystemOffNormalAlarmType_LatchedState_Id((int) 18328L),
  SystemOffNormalAlarmType_LatchedState_Name((int) 18329L),
  SystemOffNormalAlarmType_LatchedState_Number((int) 18330L),
  SystemOffNormalAlarmType_LatchedState_EffectiveDisplayName((int) 18331L),
  SystemOffNormalAlarmType_LatchedState_TransitionTime((int) 18332L),
  SystemOffNormalAlarmType_LatchedState_EffectiveTransitionTime((int) 18333L),
  SystemOffNormalAlarmType_LatchedState_TrueState((int) 18334L),
  SystemOffNormalAlarmType_LatchedState_FalseState((int) 18335L),
  SystemDiagnosticAlarmType_EventId((int) 18497L),
  SystemDiagnosticAlarmType_EventType((int) 18498L),
  SystemDiagnosticAlarmType_SourceNode((int) 18499L),
  SystemDiagnosticAlarmType_SourceName((int) 18500L),
  SystemDiagnosticAlarmType_Time((int) 18501L),
  SystemDiagnosticAlarmType_ReceiveTime((int) 18502L),
  SystemDiagnosticAlarmType_LocalTime((int) 18503L),
  SystemDiagnosticAlarmType_Message((int) 18504L),
  SystemDiagnosticAlarmType_Severity((int) 18505L),
  SystemDiagnosticAlarmType_ConditionClassId((int) 18506L),
  SystemDiagnosticAlarmType_ConditionClassName((int) 18507L),
  SystemDiagnosticAlarmType_ConditionSubClassId((int) 18508L),
  SystemDiagnosticAlarmType_ConditionSubClassName((int) 18509L),
  SystemDiagnosticAlarmType_ConditionName((int) 18510L),
  SystemDiagnosticAlarmType_BranchId((int) 18511L),
  SystemDiagnosticAlarmType_Retain((int) 18512L),
  SystemDiagnosticAlarmType_EnabledState((int) 18513L),
  SystemDiagnosticAlarmType_EnabledState_Id((int) 18514L),
  SystemDiagnosticAlarmType_EnabledState_Name((int) 18515L),
  SystemDiagnosticAlarmType_EnabledState_Number((int) 18516L),
  SystemDiagnosticAlarmType_EnabledState_EffectiveDisplayName((int) 18517L),
  SystemDiagnosticAlarmType_EnabledState_TransitionTime((int) 18518L),
  SystemDiagnosticAlarmType_EnabledState_EffectiveTransitionTime((int) 18519L),
  SystemDiagnosticAlarmType_EnabledState_TrueState((int) 18520L),
  SystemDiagnosticAlarmType_EnabledState_FalseState((int) 18521L),
  SystemDiagnosticAlarmType_Quality((int) 18522L),
  SystemDiagnosticAlarmType_Quality_SourceTimestamp((int) 18523L),
  SystemDiagnosticAlarmType_LastSeverity((int) 18524L),
  SystemDiagnosticAlarmType_LastSeverity_SourceTimestamp((int) 18525L),
  SystemDiagnosticAlarmType_Comment((int) 18526L),
  SystemDiagnosticAlarmType_Comment_SourceTimestamp((int) 18527L),
  SystemDiagnosticAlarmType_ClientUserId((int) 18528L),
  SystemDiagnosticAlarmType_AddComment_InputArguments((int) 18532L),
  SystemDiagnosticAlarmType_ConditionRefresh_InputArguments((int) 18534L),
  SystemDiagnosticAlarmType_ConditionRefresh2_InputArguments((int) 18536L),
  SystemDiagnosticAlarmType_AckedState((int) 18537L),
  SystemDiagnosticAlarmType_AckedState_Id((int) 18538L),
  SystemDiagnosticAlarmType_AckedState_Name((int) 18539L),
  SystemDiagnosticAlarmType_AckedState_Number((int) 18540L),
  SystemDiagnosticAlarmType_AckedState_EffectiveDisplayName((int) 18541L),
  SystemDiagnosticAlarmType_AckedState_TransitionTime((int) 18542L),
  SystemDiagnosticAlarmType_AckedState_EffectiveTransitionTime((int) 18543L),
  SystemDiagnosticAlarmType_AckedState_TrueState((int) 18544L),
  SystemDiagnosticAlarmType_AckedState_FalseState((int) 18545L),
  SystemDiagnosticAlarmType_ConfirmedState((int) 18546L),
  SystemDiagnosticAlarmType_ConfirmedState_Id((int) 18547L),
  SystemDiagnosticAlarmType_ConfirmedState_Name((int) 18548L),
  SystemDiagnosticAlarmType_ConfirmedState_Number((int) 18549L),
  SystemDiagnosticAlarmType_ConfirmedState_EffectiveDisplayName((int) 18550L),
  SystemDiagnosticAlarmType_ConfirmedState_TransitionTime((int) 18551L),
  SystemDiagnosticAlarmType_ConfirmedState_EffectiveTransitionTime((int) 18552L),
  SystemDiagnosticAlarmType_ConfirmedState_TrueState((int) 18553L),
  SystemDiagnosticAlarmType_ConfirmedState_FalseState((int) 18554L),
  SystemDiagnosticAlarmType_Acknowledge_InputArguments((int) 18556L),
  SystemDiagnosticAlarmType_Confirm_InputArguments((int) 18558L),
  SystemDiagnosticAlarmType_ActiveState((int) 18559L),
  SystemDiagnosticAlarmType_ActiveState_Id((int) 18560L),
  SystemDiagnosticAlarmType_ActiveState_Name((int) 18561L),
  SystemDiagnosticAlarmType_ActiveState_Number((int) 18562L),
  SystemDiagnosticAlarmType_ActiveState_EffectiveDisplayName((int) 18563L),
  SystemDiagnosticAlarmType_ActiveState_TransitionTime((int) 18564L),
  SystemDiagnosticAlarmType_ActiveState_EffectiveTransitionTime((int) 18565L),
  SystemDiagnosticAlarmType_ActiveState_TrueState((int) 18566L),
  SystemDiagnosticAlarmType_ActiveState_FalseState((int) 18567L),
  SystemDiagnosticAlarmType_InputNode((int) 18568L),
  SystemDiagnosticAlarmType_SuppressedState((int) 18569L),
  SystemDiagnosticAlarmType_SuppressedState_Id((int) 18570L),
  SystemDiagnosticAlarmType_SuppressedState_Name((int) 18571L),
  SystemDiagnosticAlarmType_SuppressedState_Number((int) 18572L),
  SystemDiagnosticAlarmType_SuppressedState_EffectiveDisplayName((int) 18573L),
  SystemDiagnosticAlarmType_SuppressedState_TransitionTime((int) 18574L),
  SystemDiagnosticAlarmType_SuppressedState_EffectiveTransitionTime((int) 18575L),
  SystemDiagnosticAlarmType_SuppressedState_TrueState((int) 18576L),
  SystemDiagnosticAlarmType_SuppressedState_FalseState((int) 18577L),
  SystemDiagnosticAlarmType_OutOfServiceState((int) 18578L),
  SystemDiagnosticAlarmType_OutOfServiceState_Id((int) 18579L),
  SystemDiagnosticAlarmType_OutOfServiceState_Name((int) 18580L),
  SystemDiagnosticAlarmType_OutOfServiceState_Number((int) 18581L),
  SystemDiagnosticAlarmType_OutOfServiceState_EffectiveDisplayName((int) 18582L),
  SystemDiagnosticAlarmType_OutOfServiceState_TransitionTime((int) 18583L),
  SystemDiagnosticAlarmType_OutOfServiceState_EffectiveTransitionTime((int) 18584L),
  SystemDiagnosticAlarmType_OutOfServiceState_TrueState((int) 18585L),
  SystemDiagnosticAlarmType_OutOfServiceState_FalseState((int) 18586L),
  SystemDiagnosticAlarmType_ShelvingState_CurrentState((int) 18588L),
  SystemDiagnosticAlarmType_ShelvingState_CurrentState_Id((int) 18589L),
  SystemDiagnosticAlarmType_ShelvingState_CurrentState_Name((int) 18590L),
  SystemDiagnosticAlarmType_ShelvingState_CurrentState_Number((int) 18591L),
  SystemDiagnosticAlarmType_ShelvingState_CurrentState_EffectiveDisplayName((int) 18592L),
  SystemDiagnosticAlarmType_ShelvingState_LastTransition((int) 18593L),
  SystemDiagnosticAlarmType_ShelvingState_LastTransition_Id((int) 18594L),
  SystemDiagnosticAlarmType_ShelvingState_LastTransition_Name((int) 18595L),
  SystemDiagnosticAlarmType_ShelvingState_LastTransition_Number((int) 18596L),
  SystemDiagnosticAlarmType_ShelvingState_LastTransition_TransitionTime((int) 18597L),
  SystemDiagnosticAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime((int) 18598L),
  SystemDiagnosticAlarmType_ShelvingState_AvailableStates((int) 18599L),
  SystemDiagnosticAlarmType_ShelvingState_AvailableTransitions((int) 18600L),
  SystemDiagnosticAlarmType_ShelvingState_UnshelveTime((int) 18601L),
  SystemDiagnosticAlarmType_ShelvingState_TimedShelve_InputArguments((int) 18603L),
  SystemDiagnosticAlarmType_SuppressedOrShelved((int) 18606L),
  SystemDiagnosticAlarmType_MaxTimeShelved((int) 18607L),
  SystemDiagnosticAlarmType_AudibleEnabled((int) 18608L),
  SystemDiagnosticAlarmType_AudibleSound((int) 18609L),
  SystemDiagnosticAlarmType_AudibleSound_ListId((int) 18610L),
  SystemDiagnosticAlarmType_AudibleSound_AgencyId((int) 18611L),
  SystemDiagnosticAlarmType_AudibleSound_VersionId((int) 18612L),
  SystemDiagnosticAlarmType_SilenceState((int) 18613L),
  SystemDiagnosticAlarmType_SilenceState_Id((int) 18614L),
  SystemDiagnosticAlarmType_SilenceState_Name((int) 18615L),
  SystemDiagnosticAlarmType_SilenceState_Number((int) 18616L),
  SystemDiagnosticAlarmType_SilenceState_EffectiveDisplayName((int) 18617L),
  SystemDiagnosticAlarmType_SilenceState_TransitionTime((int) 18618L),
  SystemDiagnosticAlarmType_SilenceState_EffectiveTransitionTime((int) 18619L),
  SystemDiagnosticAlarmType_SilenceState_TrueState((int) 18620L),
  SystemDiagnosticAlarmType_SilenceState_FalseState((int) 18621L),
  SystemDiagnosticAlarmType_OnDelay((int) 18622L),
  SystemDiagnosticAlarmType_OffDelay((int) 18623L),
  SystemDiagnosticAlarmType_FirstInGroupFlag((int) 18624L),
  SystemDiagnosticAlarmType_LatchedState((int) 18626L),
  SystemDiagnosticAlarmType_LatchedState_Id((int) 18627L),
  SystemDiagnosticAlarmType_LatchedState_Name((int) 18628L),
  SystemDiagnosticAlarmType_LatchedState_Number((int) 18629L),
  SystemDiagnosticAlarmType_LatchedState_EffectiveDisplayName((int) 18630L),
  SystemDiagnosticAlarmType_LatchedState_TransitionTime((int) 18631L),
  SystemDiagnosticAlarmType_LatchedState_EffectiveTransitionTime((int) 18632L),
  SystemDiagnosticAlarmType_LatchedState_TrueState((int) 18633L),
  SystemDiagnosticAlarmType_LatchedState_FalseState((int) 18634L),
  SystemDiagnosticAlarmType_ReAlarmTime((int) 18636L),
  SystemDiagnosticAlarmType_ReAlarmRepeatCount((int) 18637L),
  SystemDiagnosticAlarmType_NormalState((int) 18644L),
  SystemOffNormalAlarmType_Suppress2_InputArguments((int) 24449L),
  SystemOffNormalAlarmType_Unsuppress2_InputArguments((int) 24451L),
  SystemOffNormalAlarmType_RemoveFromService2_InputArguments((int) 24453L),
  SystemOffNormalAlarmType_PlaceInService2_InputArguments((int) 24455L),
  SystemOffNormalAlarmType_Reset2_InputArguments((int) 24457L),
  SystemDiagnosticAlarmType_Suppress2_InputArguments((int) 24479L),
  SystemDiagnosticAlarmType_Unsuppress2_InputArguments((int) 24481L),
  SystemDiagnosticAlarmType_RemoveFromService2_InputArguments((int) 24483L),
  SystemDiagnosticAlarmType_PlaceInService2_InputArguments((int) 24485L),
  SystemDiagnosticAlarmType_Reset2_InputArguments((int) 24487L),
  SystemOffNormalAlarmType_ShelvingState_TimedShelve2_InputArguments((int) 24923L),
  SystemOffNormalAlarmType_ShelvingState_Unshelve2_InputArguments((int) 24925L),
  SystemOffNormalAlarmType_ShelvingState_OneShotShelve2_InputArguments((int) 24927L),
  SystemDiagnosticAlarmType_ShelvingState_TimedShelve2_InputArguments((int) 24947L),
  SystemDiagnosticAlarmType_ShelvingState_Unshelve2_InputArguments((int) 24949L),
  SystemDiagnosticAlarmType_ShelvingState_OneShotShelve2_InputArguments((int) 24951L),
  SystemOffNormalAlarmType_GetGroupMemberships_OutputArguments((int) 25170L),
  SystemDiagnosticAlarmType_GetGroupMemberships_OutputArguments((int) 25173L),
  SystemEventType_ConditionClassId((int) 31875L),
  SystemEventType_ConditionClassName((int) 31876L),
  SystemEventType_ConditionSubClassId((int) 31877L),
  SystemEventType_ConditionSubClassName((int) 31878L),
  SystemStatusChangeEventType_ConditionClassId((int) 31883L),
  SystemStatusChangeEventType_ConditionClassName((int) 31884L),
  SystemStatusChangeEventType_ConditionSubClassId((int) 31885L),
  SystemStatusChangeEventType_ConditionSubClassName((int) 31886L),
  SystemOffNormalAlarmType_SupportsFilteredRetain((int) 32238L),
  SystemDiagnosticAlarmType_SupportsFilteredRetain((int) 32241L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableSystem> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableSystem value : OpcuaNodeIdServicesVariableSystem.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableSystem(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableSystem enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
